<?php
/* $Id: enfeu.class.php,v 1.8 2008-09-22 14:31:35 fraynaud Exp $
*/
require_once ("concession.class.php");
require_once ($path_om."formulairedyn.class.php");

class enfeu extends concession{

var $nature="enfeu";

function enfeu($id,&$db,$DEBUG) {
$this->constructeur($id,$db,$DEBUG);
} // fin constructeur

function setvalF($val){
$this->valF['emplacement'] = $val['emplacement'];
$this->valF['nature'] = $val['nature'];
$this->valF['numero'] = $val['numero'];
$this->valF['complement'] = $val['complement'];
$this->valF['voie'] = $val['voie'];
$this->valF['famille'] = $val['famille'];
$this->valF['numeroacte'] = $val['numeroacte'];
$this->valF['terme'] = $val['terme'];
if($val['datevente']!="")
    $this->valF['datevente'] = $this->dateDB($val['datevente']);
$this->valF['placeoccupe'] = $val['placeoccupe'];
$this->valF['observation'] = $val['observation'];
$this->valF['positionx'] = $val['positionx'];
$this->valF['positiony'] = $val['positiony'];
$this->valF['photo'] = $val['photo'];
$this->valF['plans'] = $val['plans'];
$this->valF['libre'] = $val['libre'];
// temp
$this->valF['temp1'] = $val['temp1'];
$this->valF['temp2'] = $val['temp2'];
$this->valF['temp3'] = $val['temp3'];
$this->valF['temp4'] = $val['temp4'];
$this->valF['temp5'] = $val['temp5'];
}

function verifier($val,&$db,$DEBUG){
$f="&nbsp!&nbsp;&nbsp;&nbsp;&nbsp;";
$imgv="<img src='../img/punaise.png' style='vertical-align:middle' hspace='2' border='0'>";
parent :: verifier($val,$db,$DEBUG);
// verif voie [verify street]
$sql = "select voie from voie where voie ='".$val['voie']."'";
$res = $db->query($sql);
if($DEBUG==1) echo $sql;
if (DB :: isError($res))
   die($res->getMessage(). " => Echec  ".$sql);
else{
   $nbligne=$res->numrows();
   if ($nbligne==0){
       $this->msg= $this->msg.$imgv.$this->lang("voie")." ".$val['voie'].
       " ".$this->lang("inexistant").$f;
       $this->correct=false;
    }
}
}//verifier



function setType(&$form,$maj) {
if ($maj < 2) { //ajouter et modifier  [add and modify]
  // emplacement
  $form->setType('sepulturetype','hidden');
  $form->setType('voielib','comboG');
  $form->setType('voie','textreadonly');
  $form->setType('complement', 'select');
  // terrain communal
  $form->setType('nature', 'hiddenstatic');
  $form->setType('placeoccupe', 'hiddenstatic');
  // observations
  $form->setType('observation', 'textarea');
  // terme
  $form->setType('datevente','date');
  $form->setType('terme', 'hiddenstatic');
  // plan photo
  $form->setType('plans', 'select');
  // 1.08
  include ("../dyn/var.inc");
  // compatibilit ascendante version 1.07+ [old version compatibility]
  if(!isset($photo_concession)) $photo_concession=0;
  if($photo_concession==0)
     $form->setType('photo', 'upload');
  else
      $form->setType('photo', 'hidden');
  $form->setType('positiony', 'localisation');
  $form->setType('libre','select');
  //temp
  $form->setType('temp1',$temp1_type);
  $form->setType('temp2',$temp2_type);
  $form->setType('temp3',$temp3_type);
  $form->setType('temp4',$temp4_type);
  $form->setType('temp5',$temp5_type);
  // champs non utiles   [fields not used]
  $form->setType('dateconstat','hidden');
  $form->setType('numeroacte','hidden');
  $form->setType('placeconstat','hidden');
  $form->setType('nombreplace','hidden');
  $form->setType('numerocadastre','hidden');
  $form->setType('superficie','hidden');
  $form->setType('duree', 'hidden');
  $form->setType('dateterme','hidden');
  if($maj==0){
      $form->setType('emplacement', 'hidden');
      $form->setType('sig', 'hidden');
  }else{
      $form->setType('emplacement', 'hiddenstatic');
      $form->setType('sig', 'http');
  }
}else{ // supprimer  [delete]
     $form->setType('emplacement', 'hiddenstatic');
     $form->setType('famille', 'hiddenstatic');
}}

function setSelect(&$form, $maj,$db,$debug) {
parent :: setSelect($form, $maj,$db,$debug);
include ("../dyn/var.inc");
include ("../dyn/connexion.php");
include ("../sql/".$dsn['phptype']."/".$this->table.".form.inc");
if($maj<2){
//plans
$contenu=array();
$res = $db->query($sql_plans);
if (DB :: isError($res))
     die($res->getMessage().$sql_plans);
else{
 if ($debug == 1)
   echo " la requete ".$sql_plans." est excute<br>";
   $contenu[0][0]="";
   $contenu[1][0]=$this->lang('choisir')." ".$this->lang('plans');
   $k=1;
   while ($row=& $res->fetchRow()){
    $contenu[0][$k]=$row[0];
    $contenu[1][$k]=$row[0];
    $k++;
   }
$form->setSelect("plans",$contenu);
}
// complement
$contenu=array();
$contenu[0]=array('',$this->lang("bis"),$this->lang("ter"));
$contenu[1]=array('',$this->lang("bis"),$this->lang("ter"));
$form->setSelect("complement",$contenu);
// libre  [free]
$contenu=array();
$contenu[0]=array('Non','Oui');
$contenu[1]=array($this->lang("Non"),$this->lang("Oui"));
$form->setSelect("libre",$contenu);
// position geographique [geographic position]
$contenu=array();
$contenu[0]=array('plans','positionx');
$form->setSelect("positiony",$contenu);
// lien sig [link geographic information system]
$contenu=array();
$contenu[0]="<img src='".$image_sig."'>";
$form->setSelect("sig",$contenu);
}
}

function setVal(&$form,$maj,$validation){
if ($validation==0) {
  if ($maj == 0){
       $form->setVal('terme', 'perpetuite');
       $form->setVal('nature', $this->nature);
       $form->setVal('positionx', 10); // compatibilite localisation mozilla  [compatibility mozilla]
       $form->setVal('positiony', 10); // compatibilite localisation mozilla  [compatibility mozilla]
       $form->setVal('datevente', date('Y-m-d'));
       $form->setVal('placeoccupe', 0);
}}
}

function setTaille(&$form,$maj){
$form->setTaille('emplacement', 8);
$form->setTaille('voie', 4);
$form->setTaille('numero', 3);
$form->setTaille('complement', 3);
$form->setTaille('voielib', 60);
$form->setTaille('famille', 20);
$form->setTaille('observation', 70);
$form->setTaille('plans', 20);
$form->setTaille('placeoccupe', 3);
$form->setTaille('datevente', 12);
//temp
$form->setTaille('temp1', 100);
$form->setTaille('temp2', 100);
$form->setTaille('temp3', 100);
$form->setTaille('temp4', 100);
$form->setTaille('temp5', 100);
}
function setMax(&$form,$maj){
$form->setMax('observation', 5);
$form->setMax('voielib', 40);
$form->setMax('famille', 40);
$form->setMax('placeoccupe', 8);
//temp
$form->setMax('temp1',100 );
$form->setMax('temp2',100 );
$form->setMax('temp3',100 );
$form->setMax('temp4',100 );
$form->setMax('temp5',100 );
}

function setLib(&$form,$maj) {
parent :: setLib($form,$maj);
$form->setLib('complement','');
$form->setLib('voie','');
$form->setLib('voielib','');
$form->setLib('datevente',' '.$this->lang("datevente").' ');
$form->setLib('dateterme',' '.$this->lang("dateterme").' ');
$form->setLib('terme','');
$form->setLib('placeoccupe',' '.$this->lang('placeoccupe').' ');
$form->setLib('positionx',' [X] ');
$form->setLib('positiony',' [Y] ');
$form->setLib('sig',"");
// zones temp
include ("../dyn/var.inc");
$form->setLib('temp1',$temp1_lib);
$form->setLib('temp2',$temp2_lib);
$form->setLib('temp3',$temp3_lib);
$form->setLib('temp4',$temp4_lib);
$form->setLib('temp5',$temp5_lib);
}

function setGroupe(&$form,$maj){
$form->setGroupe('numero','D');
$form->setGroupe('complement','G');
$form->setGroupe('voie','G');
$form->setGroupe('voielib','F');

$form->setGroupe('famille','D');
$form->setGroupe('datevente','G');
$form->setGroupe('terme','G');
$form->setGroupe('placeoccupe','F');

$form->setGroupe('plans','D');
$form->setGroupe('positionx','G');
if($maj==1){
    $form->setGroupe('positiony','G');
    $form->setGroupe('sig','F');
}else
    $form->setGroupe('positiony','F');
// 1.08
include ("../dyn/var.inc");
// compatibilit ascendante version 1.07+   [old version compatibility]
if(!isset($photo_concession)) $photo_concession=0;
if($photo_concession==0){
      $form->setGroupe('photo','D');
      $form->setGroupe('libre','F');
}}

function setRegroupe(&$form,$maj){
$form->setRegroupe('numero','D',' '.$this->lang('adresse').' ');
$form->setRegroupe('complement','G','');
$form->setRegroupe('voie','G','');
$form->setRegroupe('voielib','F','');
if($maj==1){
    $form->setRegroupe('plans','D',' '.$this->lang("croquis_sig").' ');
    $form->setRegroupe('positionx','G','');
    $form->setRegroupe('positiony','G','');
    $form->setRegroupe('sig','F','');
}else{
    $form->setRegroupe('plans','D',' '.$this->lang("croquis").' ');
    $form->setRegroupe('positionx','G','');
    $form->setRegroupe('positiony','F','');
}
}

}// fin de classe [end class]
?>